<template>
  <div class="home min100 bg-light">
    <div class="container-fluid pl-5 pr-5">
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
      <a class="navbar-brand" href="#">EEMI Label</a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavAltMarkup" aria-controls="navbarNavAltMarkup" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse justify-content-end" id="navbarNavAltMarkup">
        <div class="navbar-nav">
          <a class="nav-item nav-link active" href="#">Toutes les questions</a>
          

        </div>
      </div>
    </nav>
    
         <h1 class="pt-1 pb-4">{{catFilter !== null ? getCategoryById(catFilter).name : partieFilter !== null ? getPartieById(partieFilter).name :'Toutes les questions'}}</h1>
         <h5>Filtrer par catégorie : </h5>
         <b-badge pill variant="dark"   :class="'mr-2 mb-2 custom_badge2 '" @click="setCatFilter(null)">Toutes les catégories</b-badge>
         <b-badge pill variant="white" v-for="(cat, index) in categories"  :class="'mr-2 mb-2 custom_badge '+ cat.slug" :key="'catBadge'+index" :style="{background: cat.gradient}" @click="setCatFilter(cat.id)">{{cat.name}}</b-badge>
             <h5>Filtrer par partie prenante : </h5>
         <b-badge pill variant="dark"   :class="'mr-2 mb-2 custom_badge2 '" @click="setPartieFilter(null)">Toutes les parties</b-badge>
         <b-badge pill variant="white" v-for="(part, index) in parties"  :class="'mr-2 mb-2 custom_badge '+ part.slug" :key="index"  @click="setPartieFilter(part.id)">{{part.name}}</b-badge>
        <div class="row mt-2">

          <div class="col-lg-8 scrollIn">
           
            <template v-for="(q,index) in questions">
              <Question
              v-if="(catFilter === null || catFilter == q.cat) && (partieFilter === null || partieFilter == q.partie)"
              :key="q.key"
              :question="q.question"
              :categorie="getCategoryById(q.cat).name"
              :gradient="getCategoryById(q.cat).gradient"
              :partie="getPartieById(q.partie).name"
              :questionType="q.type"
              :options="q.options" 
              :value="q.value"
              :name="q.name"
              :minima="q.minima"
              :coef="q.coef"
              :block="q.block"
              :index="index + 1 + ' / '+ questions.length"
              :catSlug="getCategoryById(q.cat).slug"
              :catID="q.cat"
              @change="updateScore( $event, q.type ,index ,q.cat)"/>
            </template>
           
            
          </div>
        
        <div class="col-lg-4">
          
          <h2 class="pb-4">État de labélisation</h2>
          <ul class="list-group mb-3">
              <li v-for="(cat, index) in categories" :class="'list-group-item d-flex justify-content-between gradientOnRight lh-condensed ' + cat.slug" :key="index">
                <div>
                  <h6 class="my-0">{{cat.name}}</h6>
                  <small v-if="cat.min" class="text-muted">Min. requis : {{cat.min}}</small>
                </div>
                <span class="text-muted">{{cat.score ? cat.score : 0}}</span>
                
                <span v-if="cat.score < cat.min" class="text-danger">NON VALIDÉE</span>
                <div class="rightGradient" v-bind:style="{background: cat.gradient}"></div>
            </li>
             <li class="list-group-item d-flex justify-content-between lh-condensed mt-3 mb-3" >
                <div>
                  <h6 class="my-0">Total</h6>
                  <small class="text-muted">Min. requis : {{scoreToGetLabel}}</small>
                  <br>
                  <small class="text-danger">{{block ? 'Certaines de vos réponses bloquent la labélisation de votre école' :''}}</small>
                </div>
                <span :class="!block ? (score >= scoreToGetLabel ? 'text-success': 'text-danger') : 'text-danger'" >{{score > 0 ? score : 0 }}</span>
            </li>
            <b-button @click="() => {rapport = getTips(), downloadWithCSS()}" v-if="questionsAreChecked()">Générer le rapport</b-button>
        
            
          </ul>
          
        </div>
        <div style="position:absolute; top : -9999px; left: -9999px;">
        <div ref="content" class="myPDF" >
          <div style="margin: auto">
            <h1 class="mb-4">Rapport de labélisation</h1>
            <div v-if="(score > scoreToGetLabel) && !block" class="label">
              <h3 class="text-success">Vous êtes labelisé !!!</h3>
            </div>
            <table class="table">
              <thead>
                <tr>
                  <th>#</th>
                  <th scope="col">Question</th>
                  <th scope="col">Pistes d'amélioration</th>
                  <th scope="col">Manque à gagner</th>
                  <th scope="col">Bloquant</th>
                </tr>
                 </thead>
                <tbody>
                  <tr v-for="(r, index) in rapport" :key="index">
                    <th class="rounded" :class="r.block ? 'bg-danger' : 'bg-success'"></th>
                    <th>{{r.question}}</th>
                    <td>{{r.shouldAnswer}}</td>
                    <td>{{r.value}}</td>
                    <td>{{r.block ? "Oui" : "Non"}}</td>
                  </tr>
                </tbody>
             
            </table>
            <h3 class="mb-3 mt-3">Par question :</h3>
            <table class="table">
              <thead>
                <tr>
                  <th scope="col">#</th>
                  <th scope="col">Question</th>
                  <th scope="col">Catégorie</th>
                  <th scope="col">Score</th>
                  <th scope="col">Minimum</th>
                  <th scope="col">Bloquant</th>
                </tr>
              </thead>
                <tbody>
                  <tr v-for="(r, index) in questions" :key="index">
                    <th class="rounded" :style="{background: getCategoryById(r.cat).gradient}"></th>
                    <th>{{r.question}}</th>
                    <td>{{getCategoryById(r.cat).name}}</td>
                    <td>{{r.value}}</td>
                    <td>{{r.minima}}</td>
                    <td>{{r.minima > r.value ? "Oui" : "Non"}}</td>
                  </tr>
                </tbody>
            </table>
            <h3  class="mb-3 mt-3">Par catégorie :</h3>
            <table class="table">
              <thead>
                <tr>
                  <th scope="col">#</th>
                  <th scope="col">Catégorie</th>
                  <th scope="col">Score</th>
                  <th scope="col">Minimum</th>
                  <th scope="col">Validé</th>
                </tr>
                </thead>
                <tbody>
                  <tr v-for="(r, index) in categories" :key="index">
                    <th class="rounded" :style="{background: r.gradient}"></th>
                    <th>{{r.name}}</th>
                    <td>{{r.score}}</td>
                    <td>{{r.min}}</td>
                    <td>{{r.min > r.score ? "Non" : "Oui"}}</td>
                  </tr>
                </tbody>
              
            </table>
            </div>
        </div>
        </div>
      </div>
    </div>
  </div>

</template>

<script>
  import Question from "@/components/Question";
  import jsPDF from 'jspdf'
  import 'jspdf-autotable'
  import html2canvas from "html2canvas"
import domtoimage from "dom-to-image";
  export default {
    name: "Home",
    components: {
      Question
    },
    data(){
      return {
        date: null,
        rapport : [],
        scoreToGetLabel: 80,
        block : false,
        scoreMax: 200,
        catFilter: null,
        partieFilter: null,
        categories : [],
        parties : [],
        questions: [],
      }
    },
     mounted(){
        this.axios
          .get('https://rse-back.herokuapp.com/api/categorys')
          .then(response => (this.categories = response.data.data))
          .catch(error => console.log(error));
        this.axios
          .get('https://rse-back.herokuapp.com/api/parties')
          .then(response => (this.parties = response.data.data))
          .catch(error => console.log(error));
        this.axios
          .get('https://rse-back.herokuapp.com/api/questions')
          .then(response => (
              this.questions = response.data.data,
              this.initDisable()
              ))
          .catch(error => console.log(error));
    }, 
    computed: {
      score(){
        let score = 0;
        this.questions.map((question) =>
          score += question.value
        )
        return score;
      }
    },
    methods:{
      getCategoryById(id){
        let categoryOBject
        this.categories.forEach((category) =>{
          if (category.id == id) {
            categoryOBject= category
          }
        })
        return categoryOBject
      },
      getPartieById(id){
        let partieObject
        this.parties.forEach((partie) =>{
          if (partie.id == id) {
            partieObject= partie
          }
        })
        return partieObject
      },
      // getCurrentScore(){
      //   let allScores = Array()
      //   this.categories.map((c) =>{
      //     let questionsByCat = this.questions.filter((q)=>q.cat.id == c.id)
      //     let questionsValidateForCat = questionsByCat.filter((q)=>q.block == false)
      //     if(questionsValidateForCat.length >= questionsByCat.length * (c.minima/100)){

      //     }
      //   })
      // },
      checkIfQuestionBlock(){
        let state = false
        this.questions.forEach((q) =>{
          q.block ? state = true : state
        })
        return state
      },
      // checkIfCategoryBlock(){
      //   let state = false
      //   this.categories.forEach((q) =>{
      //     q.value < q.min ? state = true : state
      //   })
      //   return state
      // },
      setCatFilter(catID){
        this.catFilter = catID
        this.partieFilter = null
      },
      setPartieFilter(catID){
        this.partieFilter = catID
        this.catFilter = null
      },
      questionsAreChecked(){
        let bool = true
        this.questions.map(q =>{
          if(q.value === 0){
            bool = false
          }
        })
        return bool
      },
      checkIfCategoryBlock(){
         let state = false
        this.categories.map((category)=>{
          if(category.score < category.minima){
            category.block = true
            state = true
          }
          return state
        })
        
      },
      updateScore(score, type , questionID, catID){
        console.log(score)
        const reducer = (accumulator, currentValue) => parseInt(accumulator) + parseInt(currentValue);
        type !== "radio" ? score.length > 0 ? score = score.reduce(reducer) : score : score

        this.questions[questionID].value = score * this.questions[questionID].coef 
        console.log('val', this.questions[questionID].value)
        score < this.questions[questionID].minima ?
        this.questions[questionID].block = true
        : this.questions[questionID].block = false
        const category = this.getCategoryById(catID)
        const questions = this.questions.filter(q => q.cat == catID)
        let categoryScore = 0
        questions.forEach((q) =>{
          categoryScore += parseInt(q.value)
        })
        category.score = categoryScore > 0 ? categoryScore : 0
        this.block = this.checkIfCategoryBlock()
      },
      getTips(){
        let questionsResults = []
        this.questions.map((q, index) =>{
          if (this.manqueAGagner(q) > 0){
          questionsResults.push({
            id : q._id,
            value : this.manqueAGagner(q),
            question : q.question,
            answer : q.value,
            shouldAnswer : this.shouldAnswer(q),
            block : q.block
          })}
        })
        questionsResults.sort(this.compare)
        questionsResults.sort(this.compareByBlock)
        return questionsResults
      },
      compare(a, b) {
        const score1 = a.value
        const score2 = b.value

        let comparison = 0;
        if (score1 > score2) {
          comparison = 1;
        } else if (score1 < score2) {
          comparison = -1;
        }
        return comparison * -1;
      },
      compareByBlock(a, b) {
        const score1 = a.block
        const score2 = b.block

        let comparison = 0;
        if (score1 > score2) {
          comparison = 1;
        } else if (score1 < score2) {
          comparison = -1;
        }
        return comparison * -1;
      },
      manqueAGagner(q){
        let currentValue = q.value
        let valueMax = q.type == "radio" ?  q.options.sort(this.compare)[0].value  :  q.options.reduce((a, b) => ({value: a.value + b.value})).value;
        return valueMax - currentValue
      },
      shouldAnswer(q){
        return q.type == "radio" ?  'Tentez d\'obtenir : '+q.options.sort(this.compare)[0].label  :  "Obtenir plus d'éléments"
      },
      exportPDF() {
      var vm = this
      var q = [
        {title: "Question", dataKey: "question"},
        {title: "Score", dataKey: "value"},
        {title: "Minimum attendu", dataKey: "minima"}
      ];
      var c = [
        {title: "Categorie", dataKey: "name"},
        {title: "Score", dataKey: "score"},
        {title: "Minimum attendu", dataKey: "min"},
      ]
       var r = [
        {title: "Question", dataKey: "question"},
        {title: "Pistes d'amélioration", dataKey: "shouldAnswer"},
        {title: "Manque à gagner", dataKey: "value"},
      ]

      var doc = new jsPDF('p', 'pt');
      doc.text('Rapport de labelisation', 40, 40);
      doc.text('Par question :', 30, 30);
      doc.autoTable(q, vm.questions, {
        margin: {top: 40},
      });
      doc.text('Par catégorie :', 30, 30);
      doc.autoTable(c, vm.categories, {
        margin: {top: 40},
      });
      doc.text('Nos recommandations :', 30, 30);
      doc.autoTable(r, vm.rapport, {
        margin: {top: 40},
      });
      doc.save('todos.pdf');
    },
  download() {
  const doc = new jsPDF();
  const contentHtml = this.$refs.content.innerHTML;
  doc.fromHTML(contentHtml, 15, 15, {
    width: 170
  });
  doc.save("sample.pdf");
 },

  downloadWithCSS() {

   /** WITH CSS */
    domtoimage
    .toPng(this.$refs.content)
    .then(function(dataUrl) {
      var img = new Image();
      img.src = dataUrl;
      const doc = new jsPDF({
        orientation: "landscape",
        // unit: "pt",
        format: [450, 400]
      });
      doc.addImage(img, "JPEG", 20, 20);
      const date = new Date();
      const filename ="rapport_ecole_du_futur.pdf";
      doc.save(filename);
    })
    .catch(function(error) {
      console.error("oops, something went wrong!", error);
    });
 },
    }
  };
</script>
<style lang="css">
.min100{min-height: 100vh;}
.scrollIn {
    overflow-y: scroll;
    height: 600px;
}
/* .gradientOnRight:first-child:after {
    content: "";
    position: absolute;
    width: 10px;
    height: 100%;
    right: 0;
    top: 0px;
    border-top-right-radius: .25em;
} */
.gradientOnRight .rightGradient {
    content: "";
    position: absolute;
    width: 10px;
    height: 75%;
    right: 3px;
    top: 50%;
    background-size: 300% !important;
    transform: translate(0, -50%);
    opacity: .4;
    border-radius: 15px;
}
.custom_badge{
  padding: 0.75em 1em !important;
  color: #fff !important;
  opacity: .4;
  cursor: pointer;
  transition: .5s !important;
  opacity: 0.8;
}
.custom_badge2{
  padding: 0.75em 1em !important;

  cursor: pointer;
  transition: .5s !important;
  opacity: 0.8;
}
.custom_badge.partie{
  background: white !important;
}
.custom_badge:hover{
  opacity: 1;
}

</style>